
-- Display a message in the console for debugging
function Msg(value)
  if console then
    reaper.ShowConsoleMsg(tostring(value) .. "\n")
  end
end

console = true -- true/false: display debug messages in the console

--[[
1. Set Tempo.
2. Grouped all tracks.
3. Create an Action Hotkey to move to next beat and insert Stretch Marker.
4. View show Master Track.
5. Right click on Tempo points > select all
6. Right click on Tempo points > reset points to zero/center
7. Highlight from start to end.
5. Item > Snap Stretch Markers within time selection to grid.

Envelope: Select all points 40332
Envelope: Delete all selected points 40333
X-Raym Set selected tempo envelope points value.lua
--]]
function main()
--[[
  retval, bpm = reaper.GetUserInputs("Set Constant Tempo", 1, "Enter tempo (bpm):", "" )
  
  if not retval then
     reaper.defer(function () end)
     return   
  end 
--]]  
      
  start_time, end_time = reaper.GetSet_LoopTimeRange2(0, false, false, 0, 0, false)

  if start_time == end_time then 
     reaper.MB("Set Time Selection", "Set Time Selection", 0)
     reaper.defer(function () end)
     return   
  end   

  reaper.SetEditCurPos( start_time, 0, 0 )
  --tempo_marker = reaper.FindTempoTimeSigMarker( 0, start_time )
  --reaper.SetTempoTimeSigMarker( 0, tempo_marker, start_time, measurepos, beatpos, bpm, timesig_num, timesig_denom, lineartempo )   

  retval_tracks,input_choose  = reaper.GetUserInputs("All Tracks or Selected Item", 1, "Ok Yes Cancel No", "yes")
              
              
  if retval_tracks then
     reaper.Main_OnCommand(40296, 0)  -- Track: Select all tracks
     reaper.Main_OnCommand(40182, 0)  -- Item: Select all items
     reaper.Main_OnCommand(40032, 0)  -- Item grouping: Group items
  end
   cur_pos =  reaper.GetCursorPosition(0)  
  --time_out = 1
  while (cur_pos < end_time) do
     --time_out = time_out +1
     reaper.Main_OnCommand(41044, 0)  -- Move edit cursor forward one beat
     reaper.Main_OnCommand(41842, 0)  -- Item: Add stretch marker at cursor  
     cur_pos =  reaper.GetCursorPosition(0)
     if cur_pos == end_time then break end
     --if time_out >= 4000 then break end
  end
  
  
  reaper.Main_OnCommand(41046, 0)  -- Toggle show master tempo envelope 
  --reaper.Main_OnCommand(41050, 0)  -- Toggle show master track and tempo envelope 
     
  commandID1 = reaper.NamedCommandLookup("_SWS_SELMASTER")
  reaper.Main_OnCommand(commandID1, 0)  -- SWS: Select master track 

  reaper.Main_OnCommand(41864, 0)  -- Track: Select next envelope

  reaper.Main_OnCommand(40330, 0)  -- Envelope: Select points in time selection

  --reaper.Main_OnCommand(40332, 0)  -- Envelope: Unselect all points
     
  --reaper.Main_OnCommand(40331, 0)  -- Envelope: Unselect all points
  reaper.Main_OnCommand(40333, 0)  -- Envelope: Delete all selected points
  --reaper.Main_OnCommand(40415, 0)  -- Envelope: Reset selected points to zero/center

  --reaper.Main_OnCommand(40089, 0)  -- Envelope: Delete all points in time selection
    
  reaper.Main_OnCommand(41847, 0)  -- Item: Snap stretch markers in time selection to grid
  
  tempo_count = reaper.CountTempoTimeSigMarkers( 0 )
  
  for i = 1, tempo_count do
     retval, timepos, measurepos, beatpos, bpm, timesig_num, timesig_denom, lineartempo = reaper.GetTempoTimeSigMarker( 0, i )
     if timepos >= start_time and timepos < end_time then 
        reaper.DeleteTempoTimeSigMarker( 0, i ) 
     end
     if timepos > end_time then break end
  end   
  reaper.SetEditCurPos2( 0, start_time, 0, 0 )
      
  reaper.Main_OnCommand(40256, 0)  -- Tempo envelope: Insert tempo/time signature change marker at edit cursor...        

  if retval_tracks then
     reaper.Main_OnCommand(40296, 0)  -- Track: Select all tracks
     reaper.Main_OnCommand(40182, 0)  -- Item: Select all items
     reaper.Main_OnCommand(40033, 0)  -- Item grouping: Remove items from group     
     reaper.Main_OnCommand(40297, 0)  -- Track: Unselect all tracks
     reaper.Main_OnCommand(40289, 0)  -- Item: Unselect all items
  end
  reaper.Main_OnCommand(41050, 0)  -- Toggle show master track and tempo envelope  
  
  
  
  
  --reaper.AddTempoTimeSigMarker( 0, start_time, bpm, timesig_num, timesig_denom, lineartempochange )
        

 
end
    --commandID32 = reaper.NamedCommandLookup("_RS75b17c8d2da7ff0d06f8842d54ee009254e24eca")
    --reaper.Main_OnCommand(commandID32, 0)  -- Script: ReaTrak paste measures at cursor (insert).lua

reaper.PreventUIRefresh(1)

reaper.Undo_BeginBlock()

main()

reaper.UpdateArrange()
reaper.UpdateTimeline()

reaper.Undo_EndBlock( "ReaTrak set tempo mapped items in selection to constatant tempo", - 1 )

reaper.PreventUIRefresh(-1)



reaper.defer(function () end)
